* Arabic to Roman ... John Koziol May 10, 2005
* Public domain:  Share and enjoy.
cNum=INPUTBOX("Enter a number between 1 and 3999","Enter number")
nVal=VAL(cNum)
IF !BETWEEN(nVal,1,3999)
  =MESSAGEBOX(",      ?, !"," ",16)
  RETURN
ENDIF

DO MakeCTable
SET DECIMALS TO 0
USE AToRoman IN 0 ORDER MAIN ALIAS ct
SELECT ct
cRoman = ""
FOR i = 3 TO 0 STEP -1
  nAdd=10^i
  nChrs=INT(nVal/nAdd)
  SEEK nAdd
  IF i#3
    cRoman=cRoman+ICASE(nChrs=9,ct.nona,;
      BETWEEN(nChrs,5,8),ct.penta+REPLICATE(ct.symb,nChrs-5),;
      nChrs=4,ct.symb+ct.penta,;
      REPLICATE(ct.symb,nChrs))
  ELSE
    cRoman=cRoman+REPLICATE(ct.symb,nChrs)
  ENDIF
  nVal=nVal- (nChrs* ct.narabic)
ENDFOR
USE IN ct
?cRoman
RETURN

FUNCTION MakeCTable
  IF FILE("AToRoman.DBF")
    RETURN
  ENDIF
  CREATE TABLE AToRoman(narabic N(4,0), symb C(1),penta C(1), nona C(2))
  INSERT INTO AToRoman VALUES (1000,"M","","")
  INSERT INTO AToRoman VALUES (100,"C","D","CM")
  INSERT INTO AToRoman VALUES (10,"X","L","XC")
  INSERT INTO AToRoman VALUES (1,"I","V","IX")
  INDEX ON narabic TAG MAIN
  USE IN AToRoman
  RETURN
