local loGFX as xfcGraphics of Source\System.Drawing.PRG, ;
	loFont as xfcFont of Source\System.Drawing.PRG, ;
	loBrush as xfcBrush of Source\System.Drawing.PRG
local lnX, ;
	lnY, ;
	laPatterns[1], ;
	lnI, ;
	lcName, ;
	lnStyle

* Ensure GDIPlusX is available.
 
do System.app
clear
with _screen.System.Drawing as xfcDrawing of Source\System.PRG

* Create a Graphics object that draws on _SCREEN.

	loGfx = .Graphics.FromHWnd(_screen.HWnd)

* Create a hatch chart. Start by creating a font object and starting X and Y
* values.

	loFont = .Font.New('Segoe UI', 10)
	lnX    = 0
	lnY    = 20

* Fill an array with the names of the hatch patterns.

	laPatterns = _screen.System.Enum.GetNames(.Drawing2D.HatchStyle)

* Create a listing of patterns.

	for lnI = 1 to alen(laPatterns)

* Create a brush of the specified pattern and create a small filled rectangle.
* For some reason, the "Total" pattern appears in the enums but doesn't work.

		lcName  = laPatterns[lnI]
		if lcName <> 'TOTAL'
			lnStyle = .Drawing2D.HatchStyle.&lcName
			loBrush = .Drawing2D.HatchBrush.New(lnStyle, .Color.Black)
			loGfx.FillRectangle(loBrush, lnX, lnY, 20, 20)

* Draw the name of the style beside the rectangle.

			loGfx.DrawString(lcName, loFont, .Brushes.Black, lnX + 20, lnY)

* Increment the Y position and every 20 patterns, move to the next column.

			if lnI/20 = int(lnI/20)
				lnX = lnX + 250
				lnY = 20
			else
				lnY = lnY + 30
			endif lnI/20 = int(lnI/20)
		endif lcName <> 'TOTAL'
	next lnI
endwith








